#include <NmraDcc.h>

#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

//Addr: 0x3F, 20 chars & 4 lines
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);




NmraDcc  Dcc ;
DCC_MSG  Packet ;



int adresse;
int adressed;
int adresseu;
int ma;
int vitesse;
int vitessed;
int vitesseu;
int octetc;
int B[10];
int fonction1;
int fonction1d;
int fonction1u;
int fonction2;
int fonction2d;
int fonction2u;
int compteur0=0;
int compteur1;
int compteuracc0=0;
int compteuracc1;
int pinled = 13;
long t0=millis();
int adresse0=0;
int compteura=0;



// Réception des paquets de commande d'accessoires
void notifyDccAccState( uint16_t Addr, uint16_t BoardAddr, uint8_t OutputAddr, uint8_t State)
{
 compteuracc1 = Addr + OutputAddr;
 if (compteuracc1 != compteuracc0 && millis()>t0 + 1000) {
  Serial.print(Addr,DEC) ;
  Serial.println(OutputAddr,DEC) ;
  compteuracc0=compteuracc1;
  t0=millis();
  }

}


// Réception des paquets DCC de commande de locomotives
void notifyDccMsg( DCC_MSG * Msg)
{
 
  for(uint8_t i = 0; i < Msg->Size; i++)
  {
   
    adresse = Msg->Data[0];
    if (adresse>1 && compteura==0) {
    adresse0=adresse;
    compteura=1;
    }
    if (adresse>1 && adresse <99) {
    digitalWrite(pinled, HIGH); 
    adressed=int(adresse/10);
    adresseu=adresse-10*adressed;
    octetc = Msg->Data[1];
   
            B[7]=int(octetc/128);
            if(B[7]==1) octetc=octetc-128;
            B[6]=int(octetc/64);
            if(B[6]==1) octetc=octetc-64;
            B[5]=int(octetc/32);
            if(B[5]==1) octetc=octetc-32;
            B[4]=int(octetc/16);
            if(B[4]==1) octetc=octetc-16;
            B[3]=int(octetc/8);
            if(B[3]==1) octetc=octetc-8;
            B[2]=int(octetc/4);
            if(B[2]==1) octetc=octetc-4;
            B[1]=int(octetc/2);
            if(B[1]==1) octetc=octetc-2;
            B[0]=int(octetc);
            
            //  vitesse et sens de marche
            if(B[7]==0 && B[6]==1 ) {
            ma=B[5];
             vitesse=B[0]+2*B[1]+4*B[2]+8*B[3];
             vitessed=int(vitesse/10);
             vitesseu=vitesse-10*vitessed;
              
            }
            
             // fonctions du groupe 1
            if(B[7]==1 && B[6]==0 && B[5]==0 ) {
             fonction1=B[0]+2*B[1]+4*B[2]+8*B[3]+16*B[4];
             fonction1d=int(fonction1/10);
             fonction1u=fonction1-10*fonction1d;
            }
             // fonctions du groupe 2
            if(B[7]==1 && B[6]==0 && B[5]==1 && B[4]==1 ) {
             fonction2=B[0]+2*B[1]+4*B[2]+8*B[3];
             fonction2d=int(fonction2/10);
             fonction2u=fonction2-10*fonction2d;
             
            }
            
            // transmission des données au PC ou à l'ARDUINO MEGA
            compteur1=adresse+ma+vitesse+fonction1+fonction2;
            if (compteur1 != compteur0 && millis()>t0+1000) {
             Serial.print(adressed);
             Serial.print(adresseu);
             Serial.print(ma);
             Serial.print(vitessed);
             Serial.print(vitesseu);
             Serial.print(fonction1d);
             Serial.print(fonction1u);
             Serial.print(fonction2d);
             Serial.println(fonction2u);
             adresse=adresseu+10*adressed;
             if (adresse == adresse0) {
             lcd.setCursor(3, 0);
             lcd.print(adressed);
             lcd.setCursor(4, 0);
             lcd.print(adresseu);
             lcd.setCursor(12, 0);
             if (ma==1) lcd.print("+");
             if (ma==0) lcd.print("-");
             lcd.setCursor(13, 0);
             lcd.print(vitessed);
             lcd.setCursor(14, 0);
             lcd.print(vitesseu);
             lcd.setCursor(3, 1);
             lcd.print(fonction1d);
             lcd.setCursor(4, 1);
             lcd.print(fonction1u);
             lcd.setCursor(12, 1);
             lcd.print(fonction2d);
             lcd.setCursor(13, 1);
             lcd.print(fonction2u);
             }
             
             if (adresse != adresse0) {
             lcd.setCursor(3, 2);
             lcd.print(adressed);
             lcd.setCursor(4, 2);
             lcd.print(adresseu);
             lcd.setCursor(12, 2);
             if (ma==1) lcd.print("+");
             if (ma==0) lcd.print("-");
             lcd.setCursor(13, 2);
             lcd.print(vitessed);
             lcd.setCursor(14, 2);
             lcd.print(vitesseu);
             lcd.setCursor(3, 3);
             lcd.print(fonction1d);
             lcd.setCursor(4, 3);
             lcd.print(fonction1u);
             lcd.setCursor(12, 3);
             lcd.print(fonction2d);
             lcd.setCursor(13, 3);
             lcd.print(fonction2u); 
             }
            t0=millis(); 
            compteur0=compteur1;  
            }
            
    }
            
            
            
            
            
  }
 
}





void setup()
{
  Serial.begin(9600);
  pinMode(pinled, OUTPUT); 
  
  digitalWrite(pinled, LOW); 
  lcd.begin(20,4); 
  lcd.backlight(); // finish with backlight on 
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("A1=");
  lcd.setCursor(9, 0);
  lcd.print("V1=");
  lcd.setCursor(0, 1);
  lcd.print("F1=");
  lcd.setCursor(9, 1);
  lcd.print("F2=");
  lcd.setCursor(0, 2);
  lcd.print("A2=");
  lcd.setCursor(9, 2);
  lcd.print("V2=");
  lcd.setCursor(0, 3);
  lcd.print("F1=");
  lcd.setCursor(9, 3);
  lcd.print("F2=");

  Serial.println("NMRA DCC Example 1");
  // Call the main DCC Init function to enable the DCC Receiver
  Dcc.init( MAN_ID_DIY, 10, FLAGS_OUTPUT_ADDRESS_MODE | FLAGS_DCC_ACCESSORY_DECODER | FLAGS_ENABLE_INT0_PULL_UP, 0 );
  Serial.println("Init Done");
}

void loop()
{
 
  Dcc.process();
}
